﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace rghost_mail
{
    public partial class FrmMain : Form
    {
        public delegate void ChangeUI(string data);
        private ChangeUI myUI;
        private UI ui;

        public void parseURLS(string data)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(myUI, data);
                return;
            }

            listURLS.Items.Add(data);
        }

        public void parseMAILS(string data)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(myUI, data);
                return;
            }

            richTextBox1.Text += data + '\n';
        }

        public FrmMain()
        {
            InitializeComponent();
        }

        private void buttonGetURLS_Click(object sender, EventArgs e)
        {
            myUI = new ChangeUI(parseURLS);
            ui = new UI(myUI);

            GetLinks.Start(textSearchString.Text, Convert.ToInt32(numericCountPGS.Value));
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            myUI = new ChangeUI(parseMAILS);
            ui = new UI(myUI);

            ParseMails.Start();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            listURLS.Items.Clear();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (listURLS.SelectedIndex != -1) listURLS.Items.RemoveAt(listURLS.SelectedIndex);
            else MessageBox.Show("Select element for remove....");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            if (sfd.ShowDialog() == DialogResult.OK)
                File.WriteAllText(sfd.FileName, richTextBox1.Text);

        }
    }
}
